/**
Universitat que, analitzant totes les dades de que disposem, t un percentatge ms alt 
destudiants que superen les prctiques en empreses. Es consideren superades quan la 
persona responsable de lestudiant a lempresa el qualifica com a apte. 
**/

/** Consulta sense temps constant 1**/
select universitat_id, universitat_nom, total_candidats_finalitzats, total_estudiants_aprovats,
        to_char( (t2.total_estudiants_aprovats/total_candidats_finalitzats)*100, '999D99') || '%' as percentatge
from(
    select t1.id as universitat_id, t1.nom as universitat_nom,
            ( select count(contracte_practiques.id)
            from universitat, oferta_treball, contracte_practiques
            where oferta_treball.universitat_id = universitat.id
                    and oferta_treball.id = contracte_practiques.oferta_treball_id
                    and contracte_practiques.es_apte = 1
                    and universitat.id = t1.id
            group by universitat.id, universitat.nom  ) as total_estudiants_aprovats,
            ( select count(contracte_practiques.id)
            from universitat, oferta_treball, contracte_practiques
            where oferta_treball.universitat_id = universitat.id
                    and oferta_treball.id = contracte_practiques.oferta_treball_id
                    and universitat.id = t1.id
            group by universitat.id, universitat.nom
            ) as total_candidats_finalitzats
    from universitat t1
    
 ) t2   
 order by total_estudiants_aprovats, total_candidats_finalitzats   ;

/** consulta modul estadistic**/

select universitat.nom as universitat_nom,estudiants_aprovats, estudiants_finalitzats,
        to_char( (estudiants_aprovats/estudiants_finalitzats)*100, '999D99') || '%' as percentatge
from e_estudiants_per_universitat, universitat
where universitat.id = e_estudiants_per_universitat.universitat_id and estudiants_finalitzats>0
order by percentatge desc, estudiants_aprovats desc
fetch first 1 row only ;

/*********************************************************************************************************/

/**
Top5 dempreses que han ofert ms places per estudiants en prctiques al CIC. 
**/

/** Consulta sense temps constant 1**/
select companyia.cif as companyia_cif, companyia.nom as companyia_nom,
    count(oferta_treball.id) as total_places
from companyia, oferta_treball
where oferta_treball.companyia_cif = companyia.cif
group by companyia.cif, companyia.nom
order by total_places desc;

/** altra consulta directa **/
select distinct companyia.cif as companyia_cif, companyia.nom as companyia_nom,
    count(oferta_treball.id) over (partition by companyia.cif) as total_places
from companyia, oferta_treball
where oferta_treball.companyia_cif = companyia.cif
order by total_places desc;

/** consulta modul estadistic**/
select companyia.nom as companyia_nom,
        total_ofertes_treball as total_ofertes
from companyia, e_companyia_dades
where companyia.cif = e_companyia_dades.companyia_cif
order by total_ofertes desc
fetch first 5 row only;

/*********************************************************************************************************/

/**
Empresa que, dentre totes les dades de que disposem, ha rebut ms inspeccions de treball (sense considerar el resultat de la inspecci). 
**/
/** Consulta sense temps constant 1 **/
select companyia.cif as companyia_cif, companyia.nom as companyia_nom,
    count(inspeccio_treball.id) as total_inspeccions
from companyia, oferta_treball, contracte_practiques, inspeccio_treball
where oferta_treball.companyia_cif = companyia.cif
    and contracte_practiques.oferta_treball_id = oferta_treball.id
    and contracte_practiques.id = inspeccio_treball.contracte_practiques_id
group by companyia.cif, companyia.nom
order by total_inspeccions desc;

/** consulta modul estadistic**/
select companyia.nom as companyia_nom,
        total_inspeccions_rebudes as total_inspeccions
from companyia, e_companyia_dades
where companyia.cif = e_companyia_dades.companyia_cif
order by total_inspeccions desc
fetch first 1 row only;


/*********************************************************************************************************/
/**
Donat un any universitari en concret, percentatge destudiants, de qualsevol universitat, que no superen les prctiques en empreses. 
**/

/** consulta modul estadistic per universitat i any**/
select any_universitari_id as any_universitari,
        to_char( 100 - (estudiants_aprovats/estudiants_finalitzats)*100, '999D99') || '%' as percentatge_aprovats
from e_estudiants_per_universitat_i_any_universitari
where any_universitari_id = 1 and universitat_id = 1 and estudiants_finalitzats>0;

/** consulta modul estadistic per any universitari**/
select any_universitari_id as any_universitari,
        to_char( 100- (estudiants_aprovats/estudiants_finalitzats)*100, '999D99') || '%' as percentatge_aprovats
from e_estudiants_any_universitari
where any_universitari_id = 1 ;


/*********************************************************************************************************/
/**
En lany universitari en curs, sou mitj que reben els estudiants durant les serves prctiques. 
**/

/** Total de sous **/
select ( select sum(sou) from contracte_practiques) as total_per_taula,
    ( select sum(sou_total) from e_estudiants_any_universitari) as total_per_any_universitari,
    ( select sum(sou_total) from e_estudiants_per_universitat_i_any_universitari) as total_per_any_universitari_i_universitat,
    ( select sum(sou_total) from e_estudiants_per_universitat) as total_per_universitat
from dual;

/** consulta modul estadistic per any universitari**/
select to_char( sou_total / estudiants_finalitzats, '9999D99') || ' sou mitj l''any universitari ' || e_any_universitari.any_universitari as avg_sou
from e_estudiants_any_universitari, e_any_universitari
where e_any_universitari.id = any_universitari_id 
        and any_universitari_id= 1;

/** consulta modul estadistic per universitat i any universitari**/
select universitat.nom as universitat_nom,
        to_char( sou_total / estudiants_finalitzats, '9999D99') || ' sou mitj l''any universitari ' || e_any_universitari.any_universitari as avg_sou
from e_estudiants_per_universitat_i_any_universitari, e_any_universitari, universitat
where e_any_universitari.id = e_estudiants_per_universitat_i_any_universitari.any_universitari_id 
        and universitat.id = e_estudiants_per_universitat_i_any_universitari.universitat_id
        and e_estudiants_per_universitat_i_any_universitari.any_universitari_id= 1;

/** consulta modul estadistic per universitat**/
select universitat.nom as universitat_nom,
        to_char( sou_total / estudiants_finalitzats, '9999D99') || ' sou mitj '  as avg_sou
from e_estudiants_per_universitat, universitat
where universitat.id = e_estudiants_per_universitat.universitat_id
        and e_estudiants_per_universitat.universitat_id= 1;

/*********************************************************************************************************/
/**
Nmero total destudiants en prctiques en el moment de fer la consulta. Es consideraran els estudiants que han comenat les prctiques i no les tenen acabades en aquell moment. 
**/

/** consulta modul estadistic**/
select estudiants_seleccionats - estudiants_finalitzats as total_estudiants_sense_aprovar
from e_estudiants_dades
where id = 1;

/**
Durant el darrer any universitari, percentatge duniversitats controlades pel CIC que no tenen cap estudiant en prctiques. 
**/

/** consulta modul estadistic**/
select to_char( (100- (total_amb_estudiants/total)*100), '999D99') || '%' as percentatge_sense_estudiants
from (
    select 
        (select count(universitat_id) from e_estudiants_per_universitat_i_any_universitari where any_universitari_id = 1) as total_amb_estudiants,
        (select count(id) as total from universitat) as total
    from dual
) t1;

/**
Titulaci universitria amb un major nmero destudiants que han acabat satisfactriament les prctiques en empreses. Es tindran en compte totes les dades de que es disposa a la BD. 
**/

/** consulta sense temps constant 1**/
select titulacio.nom as titulacio_nom,
        count(contracte_practiques.id) as total
from contracte_practiques, oferta_treball, titulacio
where data_informe is not null and es_apte = 1
    and contracte_practiques.oferta_treball_id = oferta_treball.id
    and titulacio.id = oferta_treball.titulacio_id
group by titulacio.nom
order by total desc;

/** consulta modul estadistic**/
select titulacio.nom as titulacio_nom,
        e_titulacio_dades.total_estudiants_en_practiques_finalitzat_satisfactori as total
from titulacio, e_titulacio_dades
where titulacio.id = e_titulacio_dades.titulacio_id
order by total_estudiants_en_practiques_finalitzat_satisfactori desc
fetch first 1 row only;

/**
Nmero mig destudiants que es presenten a cada oferta rebuda per les diferents universitats durant lany universitari en curs. 
**/

/** consulta modul estadistic**/
select universitat.nom as universitat_nom, 
    to_char( estudiants_presentats / total_ofertes_treball, '99D99') || ' estudiants per oferta'  as mitja
from e_estudiants_per_universitat_i_any_universitari, universitat
where  universitat.id = e_estudiants_per_universitat_i_any_universitari.universitat_id
        and any_universitari_id in ( 
                select id
                from e_any_universitari
                where any_universitari = '22/23'
            );

/**
Tenint en compte totes les dades de que es disposa, durada mitja dels contractes destudiants amb les empreses. 
**/

/** consulta sense modul estadistic**/
select extract(month from t3.mitja) || ' mesos, '
        || extract(day from t3.mitja) || ' dies, '
        || extract(hour from t3.mitja) || ' hores, '
        || extract(minute from t3.mitja) || ' minuts i '
        || trunc( to_number( extract(second from t3.mitja) )) || ' segons '
        as mitja_durada
from(
    select 
    (t2.diferencia_dates_total / total_contractes),
    to_timestamp( '1970-01-01', 'YYYY-MM-DD' ) + NUMTODSINTERVAL( (t2.diferencia_dates_total / total_contractes), 'SECOND' ) as mitja
    
    from(
        select sum(t1.diferencia_total) over () as diferencia_dates_total,
                (select count(id) from contracte_practiques) as total_contractes
        from (
            select data_inici, data_fi, (data_fi - data_inici), (data_fi - data_inici) as diferencia_dates, extract( day from ((data_fi - data_inici) * 86400)) as diferencia_total
            from contracte_practiques
        ) t1
        fetch first 1 row only
    ) t2
) t3;

/** consulta modul estadistic**/
select extract(month from t1.mitja) || ' mesos, '
        || extract(day from t1.mitja) || ' dies, '
        || extract(hour from t1.mitja) || ' hores, '
        || extract(minute from t1.mitja) || ' minuts i '
        || trunc( to_number( extract(second from t1.mitja) )) || ' segons '
        as mitja_durada
from(
    select 
    ((dies_total_contracte * 86400) /total_contractes),
    to_timestamp( '1970-01-01', 'YYYY-MM-DD' ) + NUMTODSINTERVAL( ((dies_total_contracte * 86400) /total_contractes), 'SECOND' ) as mitja
    from e_estudiants_dades
) t1;

/**
Empresa que, en un any concret, ha realitzat el major nmero dentrevistes a estudiants. 
**/

select distinct companyia_cif,
    count(candidat.id) over (partition by companyia_cif) as total
    
from oferta_treball, candidat
where  oferta_treball.id = candidat.oferta_treball_id
        and extract(year from oferta_treball.data_creacio) = 2022
        and candidat.validat_per is not null
order by total desc
fetch first 1 row only;

/**
En lany universitari en curs, professor que porta un major nmero destudiants que estan fent prctiques en empreses. 
**/

/** consulta modul estadistic**/
select universitat.nom as universitat_nom,
        professor.nif as professor_nif, professor.nom as professor_nom,
        total_estudiants_en_practiques
from e_professor_i_any_universitari, universitat, professor
where any_universitari_id in (
    select id
    from e_any_universitari
    where any_universitari = '22/23'
)
order by total_estudiants_en_practiques desc
fetch first 1 rows only;

/**
En el moment dexecutar la consulta, nmero total dinformes de prctiques pendents de ser realitzats per les persones responsables de les empreses. 
**/

select count(id) as total_contractes_sense_informes
from contracte_practiques
where id not in (
    select contracte_practiques_id
    from informe_parcial
);


/**
Tenint en compte lany universitari en curs i lanterior, percentatge dempreses que van oferir places lany anterior i no nhan ofert en lactual. 

NOTA: s'ha de tenir en compte nomes les empreses que van oferir places l'any anterior, ja que l'any actual
potser te empreses que no van oferir plaes l'any anterior i no s'ha de tenir en compte. Per exemple,
l'any universitari 21/22 van oferir plaes les companyies C1 i C2, pero l'any universitari 22/23 van oferir
plaes les empreses C1, C3, C4 i C5, llavors nomes hi ha una empresa de dues, ja de les dues empreses
de l'any 21/22, nomes una no ha ofert plaes l'any 22/23. Llavors la formula es diferencia/total any anterior.
En l'exemple seria 1/2 = 0.5 => 50%
**/

/** Comparativa d'anys universitaris **/
 select 'total any 22/23' as any_universitari, companyia_cif
from e_companyia_dades_i_any_universitari
where any_universitari_id in (
    select id
    from e_any_universitari
    where any_universitari  = '22/23'
) 

union 

select 'total any 21/22' as any_universitari, companyia_cif
from e_companyia_dades_i_any_universitari
where any_universitari_id in (
    select id
    from e_any_universitari
    where any_universitari  = '21/22'
)

union 

select 'total any 20/21' as any_universitari, companyia_cif
from e_companyia_dades_i_any_universitari
where any_universitari_id in (
    select id
    from e_any_universitari
    where any_universitari  = '20/21'
)
order by companyia_cif, any_universitari;

/** consulta mdul estadistic **/
select t1.total_any_anterior,
        t1.diferencia,
        (case when t1.diferencia = 0 then '0%' 
            when t1.total_any_anterior = 0 then 'No hi ha dades de l''any anterior'
            else to_char(t1.diferencia/t1.total_any_anterior *100, '999D99') || '%'
        end )  as percentatge
            
from (
     
    select (select count(companyia_cif)
                from e_companyia_dades_i_any_universitari
                where any_universitari_id in (
                    select id
                    from e_any_universitari
                    where any_universitari  = '21/22'
                ) 
        ) as total_any_anterior,
                
        (select count(companyia_cif)
                from e_companyia_dades_i_any_universitari
                where any_universitari_id in (
                    select id
                    from e_any_universitari
                    where any_universitari  = '21/22'
                ) and companyia_cif not in (
                        select companyia_cif
                        from e_companyia_dades_i_any_universitari
                        where any_universitari_id in (
                            select id
                            from e_any_universitari
                            where any_universitari  = '22/23'
                        ) 
                    )
        ) as diferencia
    from dual
) t1;

